package com.example.stefano.maps3;


import android.Manifest;
import android.content.Context;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.location.Location;
import android.location.LocationManager;
import android.location.LocationListener;
import android.location.LocationProvider;
import android.os.Build;
import android.os.SystemClock;
import android.support.v4.app.ActivityCompat;
import android.support.v4.app.FragmentActivity;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.util.Log;
import android.view.View;
import android.widget.Chronometer;


//import com.google.android.gms.location.LocationListener;
import com.google.android.gms.location.LocationServices;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.MapFragment;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.android.gms.maps.model.Polyline;
import com.google.android.gms.maps.model.PolylineOptions;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;


public class MapsActivity extends FragmentActivity implements OnMapReadyCallback, LocationListener {

    private GoogleMap mMap;
    List<Double> listLong = new ArrayList<Double>();
    List<Double> listLat = new ArrayList<Double>();
    double distance = 0;
    double realdistance = 0;
    double fakeavgspeed = 0;
    double realavgspeed = 0;
    double maxspeed = 0;
    double time = 0;

    int i=0;

    @Override
    protected void onCreate(Bundle savedInstanceState) {


        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_maps);
        // Obtain the SupportMapFragment and get notified when the map is ready to be used.
        MapFragment mapFragment = (MapFragment) getFragmentManager()
                .findFragmentById(R.id.map);
        mapFragment.getMapAsync(this);
        LocationManager locationManager = (LocationManager) this.getSystemService(Context.LOCATION_SERVICE);



        if (android.os.Build.VERSION.SDK_INT >= 23 && ContextCompat.checkSelfPermission(this,
                Manifest.permission.ACCESS_COARSE_LOCATION) == PackageManager.PERMISSION_DENIED) {
            requestPermissions(new String[]{Manifest.permission.ACCESS_COARSE_LOCATION}, 1);
        }

        locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 500, 1, this);

    }


    public void startChronometer(View view) {
        ((Chronometer) findViewById(R.id.chronometer1)).setBase(SystemClock.elapsedRealtime());
        ((Chronometer) findViewById(R.id.chronometer1)).start();
    }
    public void stopChronometer(View view) {
        ((Chronometer) findViewById(R.id.chronometer1)).stop();
    }

    public double CalculationByDistance(LatLng StartP, LatLng EndP) {
        int Radius = 6371;// radius of earth in Km
        double lat1 = StartP.latitude;
        double lat2 = EndP.latitude;
        double lon1 = StartP.longitude;
        double lon2 = EndP.longitude;
        double dLat = Math.toRadians(lat2 - lat1);
        double dLon = Math.toRadians(lon2 - lon1);
        double a = Math.sin(dLat / 2) * Math.sin(dLat / 2)
                + Math.cos(Math.toRadians(lat1))
                * Math.cos(Math.toRadians(lat2)) * Math.sin(dLon / 2)
                * Math.sin(dLon / 2);
        double c = 2 * Math.asin(Math.sqrt(a));
        double valueResult = Radius * c;
        double km = valueResult / 1;
        DecimalFormat newFormat = new DecimalFormat("####");
        int kmInDec = Integer.valueOf(newFormat.format(km));
        double meter = valueResult % 1000;
        int meterInDec = Integer.valueOf(newFormat.format(meter));
        //Log.i("Radius Value", "" + valueResult + "   KM  " + kmInDec
        //        + " Meter   " + meterInDec);

        return Radius * c;
    }

    public double CalculationByAvgSpeed(double x, double t){
        double speed;
        if (x == 0){
            return 0;
        }
        speed = (x/t);
        if (maxspeed < speed) {
            maxspeed = speed;
        }
        return speed;
    }


    @Override
    public void onMapReady(GoogleMap googleMap) {
//        mMap.setMapType(MAP_TYPE_HYBRID);
        mMap = googleMap;
        mMap.setMapType(GoogleMap.MAP_TYPE_HYBRID);
//        //Create a geographic point starting from latitude and longitude coordinate
        LatLng parmaUniversity = new LatLng(44.76516282282244, 10.311720371246338);
//        //Enable or disable user location layer
        mMap.addMarker(new MarkerOptions().position(parmaUniversity).title("Marker in Parma"));
//        //Move the map to a specific point
        mMap.moveCamera(CameraUpdateFactory.newLatLngZoom(parmaUniversity, 13));
    }

    @Override
    public void onLocationChanged(Location location) {
        double lati = location.getLatitude();
        double longi = location.getLongitude();
        listLat.add(lati);
        listLong.add(longi);
        LatLng newPosition = new LatLng(lati, longi);
        //mMap.addMarker(new MarkerOptions().position(newPosition).title("Nuova Posizione"));
        mMap.moveCamera(CameraUpdateFactory.newLatLng(newPosition));

        //System.out.printf("\nLAT: %f\nLONG: %f\n", listLat.get(i), listLong.get(i));
        i++;
        //qui devo aprire connessione col database in tabella nuova che si chiamera "posizioni"
        //che consentira di memorizzare le posizioni

        if (listLat.size() >= 2){
            distance = 0;
            realdistance = 0;
            fakeavgspeed = 0;
            int k;
            for(k=0; k < (listLat.size()-1); k++) {

                LatLng initPosition = new LatLng(listLat.get(k), listLong.get(k));
                LatLng finalPosition = new LatLng(listLat.get(k+1), listLong.get(k+1));
                distance = distance + CalculationByDistance(initPosition, finalPosition);
                realdistance = CalculationByDistance(initPosition, finalPosition);

                Polyline line = mMap.addPolyline(new PolylineOptions()
                        .add(new LatLng(listLat.get(k), listLong.get(k)),
                                new LatLng(listLat.get(k + 1), listLong.get(k + 1)))
                        .width(5)
                        .color(Color.RED));
                long elapsedMillis = SystemClock.elapsedRealtime() - ((Chronometer) findViewById(R.id.chronometer1)).getBase();
                time = (new Long(elapsedMillis).doubleValue()-time);
                time = (time/3600000);//in ore

                fakeavgspeed = (fakeavgspeed + CalculationByAvgSpeed(realdistance, time));
                realavgspeed = (fakeavgspeed/(k+1));

            }
            System.out.printf("Sono passate: %f ore\n", time);//tempo totale
            System.out.printf("La distanza é di : %f km\n", distance);//distanza totale
            System.out.printf("La velocita avg é: %f km/h\n", realavgspeed);//avg speed totale
            System.out.printf("La velocita max é: %f km/h\n", maxspeed);//max speed totale
        }





    }

    @Override
    public void onStatusChanged(String provider, int status, Bundle extras) {

    }

    @Override
    public void onProviderEnabled(String provider) {

    }

    @Override
    public void onProviderDisabled(String provider) {

    }
}
